/*
 * MyCanvasOracle.java
 *
 * Created on 24 de marzo de 2005, 12:58
 */

package learningbom;

import oracle.FactorOracle;
import javax.swing.JPanel;

import oracle.FactorOracleConst;
import oracle.NodeOracle;


/**
 *
 * @author Alejandro Touza Paredes
 */
public class MyCanvasOracleMultiple extends MyCanvasOracle{
    
    private int numberOfPatterns;
    //CONSTRUCTORAS
    /** Crea una nueva instancia de MyCanvasOracle
     *  @param x Coordenada x donde se situar MyCanvasOracle
     *  @param y Coordenada y donde se situar MyCanvasOracle
     *  @param d Dimensiones de MyCanvasOracle */ 
    public MyCanvasOracleMultiple(JPanel jpanel){
        
        super(jpanel);
        numberOfPatterns = 0;
    }
    
    public void start(String pattern){
        
        super.resetParameters();
        start = true;
        //Revisar el cambio de cursor si te acuerdas al final
        //setCursor(cSelect);
        fo = new FactorOracle(pattern);
        numberOfPatterns = 1;
    }
    
    public void start(String pattern, String patternTwo){
        
        super.resetParameters();
        start = true;
        //Revisar el cambio de cursor si te acuerdas al final
        //setCursor(cSelect);
        fo = new FactorOracle(pattern, patternTwo);
        numberOfPatterns = 2;
    }
    
    public void start(String pattern, String patternTwo, String patternThree){
        
        super.resetParameters();
        start = true;
        //Revisar el cambio de cursor si te acuerdas al final
        //setCursor(cSelect);
        fo = new FactorOracle(pattern, patternTwo, patternThree);
        numberOfPatterns = 3;
    }
    
    public void complete(){
        
        switch (fo.numberOfPatterns())
        {
            case 1: fo = new FactorOracle(fo.pattern());
                    break;
            case 2: fo = new FactorOracle(fo.pattern(), fo.patternTwo());
                    break;
            case 3: fo = new FactorOracle(fo.pattern(), fo.patternTwo(), fo.patternThree());
                    break;
        }
        fo.Oracle();
        //ponemos a Null la Transicin current para que no la pinte
        currentTransition = null;
        currentNodeOracle = null;
    }
  
    public void reset(){
        
        if(start)
        {
            super.resetParameters();
            setCursor(cSelect);
            if (!searchMode) 
                switch (fo.numberOfPatterns())
                {
                    case 1: fo = new FactorOracle(fo.pattern());
                            break;
                    case 2: fo = new FactorOracle(fo.pattern(), fo.patternTwo());
                            break;
                    case 3: fo = new FactorOracle(fo.pattern(), fo.patternTwo(), fo.patternThree());
                            break;
                }       
        }
    }
    
    /** Retrocede un paso del Grafo Oracle y lo pinta. 
     *  @return Nmero de paso actual. */
    public int stepBack(){
        
        if(numberOfSteps <= 1) reset(); //el reset tb pondr a 0 numberOfSteps
        else //tenemos algn paso al que retroceder diferente del inicio
        {
            //Reseteamos el GraphOracle
            switch (fo.numberOfPatterns())
            {
                case 1: fo = new FactorOracle(fo.pattern());
                        break;
                case 2: fo = new FactorOracle(fo.pattern(), fo.patternTwo());
                        break;
                case 3: fo = new FactorOracle(fo.pattern(), fo.patternTwo(), fo.patternThree());
                        break;
            }
                       
            //Restamos el paso que hacemos atrs
            numberOfSteps--;
            for(int i=1; i< numberOfSteps; i++) fo.step();
                       
            //En el ltimo paso recogemos los datos necesarios para el mostrado
            int n = fo.getTotalTransitions();
            currentTransition = fo.step();
            // Si antes de llamar a go.step() haba menos transiciones es que se ha creado una nueva
            currentTransitionIsNew = (n < fo.getTotalTransitions());
        
            // En el paso 0 el nodo Actual es el siguiente del que queremos mostrar como actual
            if (fo.getCurrentStep() == FactorOracleConst.STEP_0)
                 currentNodeOracle = (NodeOracle)fo.getNode(fo.getCurrentNodeValue()-1);
            else currentNodeOracle = (NodeOracle)fo.getCurrentNode();
       }
       return numberOfSteps;
    }
} 
